package data.hullmods;

import java.util.HashMap;
import java.util.Map;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
//import com.fs.starfarer.api.impl.campaign.ids.Factions;
//import com.fs.starfarer.api.impl.campaign.ids.Stats;
import com.fs.starfarer.api.util.Misc;

public class CHM_xlu extends BaseHullMod {

	public static final float BALLISTIC_BONUS_FRIGATE = 15f;
	public static final float BALLISTIC_BONUS_DESTROYER = 10f;
	public static final float BALLISTIC_BONUS_CRUISER = 5f;
	public static final float BALLISTIC_BONUS_CAPITAL = 5f;
	public static final float BALLISTIC_FLUX_FRIGATE = 20f;
	public static final float BALLISTIC_FLUX_DESTROYER = 15f;
	public static final float BALLISTIC_FLUX_CRUISER = 10f;
	public static final float BALLISTIC_FLUX_CAPITAL = 10f;
        //public static final float BALLISTIC_BONUS = 5f;
        //public static final float BALLISTIC_FLUX = 10f;
        //public static final float ACCURACY_DEBUFF = 15f;
        
    @Override
    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

            if (hullSize == HullSize.FRIGATE) {
                stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS_FRIGATE);
            } else if (hullSize == HullSize.DESTROYER) {
                stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS_DESTROYER);
            } else if (hullSize == HullSize.CRUISER) {
                stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS_CRUISER);
            } else if (hullSize == HullSize.CAPITAL_SHIP) {
                stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS_CAPITAL);
            }
            if (hullSize == HullSize.FRIGATE) {
                stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 - (BALLISTIC_FLUX_FRIGATE / 100)));
            } else if (hullSize == HullSize.DESTROYER) {
                stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 - (BALLISTIC_FLUX_DESTROYER / 100)));
            } else if (hullSize == HullSize.CRUISER) {
                stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 - (BALLISTIC_FLUX_CRUISER / 100)));
            } else if (hullSize == HullSize.CAPITAL_SHIP) {
                stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 - (BALLISTIC_FLUX_CAPITAL / 100)));
            }
            //stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS);
            //stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 -(BALLISTIC_FLUX / 100)));
            //stats.getAutofireAimAccuracy().modifyPercent(id, ACCURACY_DEBUFF);
    }
    
    @Override
    public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
                if (ship.getVariant().hasHullMod("CHM_commission")) {
                    ship.getVariant().removeMod("CHM_commission");
                }
    }
    
    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
		
	if(index == 0) return "" + (int) (BALLISTIC_BONUS_FRIGATE) + "%/" + (int) (BALLISTIC_BONUS_DESTROYER) + "%/" + (int) (BALLISTIC_BONUS_CRUISER) + "%/" + (int) (BALLISTIC_BONUS_CAPITAL) + "%";
	if(index == 1) return "" + (int) (BALLISTIC_FLUX_FRIGATE) + "%/" + (int) (BALLISTIC_FLUX_DESTROYER) + "%/" + (int) (BALLISTIC_FLUX_CRUISER) + "%/" + (int) (BALLISTIC_FLUX_CAPITAL) + "%";
	//if (index == 2) return "" + (int) ACCURACY_DEBUFF + "%";
	//if (index == 4) return "" + (int) BALLISTIC_BONUS + "%";
	//if (index == 5) return "" + (int) BALLISTIC_FLUX + "%";
        else {
            return null;
        }
    }

}
