package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class xlu_armorclad extends BaseHullMod {

        public static final float ARMOR_BONUS_BASE = 25f;
	public static final float ARMOR_FIGHTER = 150f;
	public static final float ARMOR_FRIGATE = 250f;
	public static final float ARMOR_DESTROYER = 350f;
	public static final float ARMOR_CRUISER = 500f;
	public static final float ARMOR_CAPITAL = 700f;
        public static final float ENGINE_HEALTH_FIGHTER = 1.75f;
        public static final float WEAPON_HEALTH_FIGHTER = 1.5f;
	public static final float REPAIR_RATE_FIGHTER = 67f;
//        public static final float EMP_RESIST_FIGHTER = 0.75f;
        public static final float KINETIC_RESIST = 0.25f;
//        public static final float FRAG_RESIST = 0.25f;
//	  public static final float ARMOR_COMPOSITE = 0.25f;
//        public static final float SHIELD_MOVEMENT_PENALTY = 0.5f;
//        public static final float SHIELD_PENALTY = 0.5f;
        public static final float TURRET_PENALTY = 0.33f;
        public static final float EXPLOSIVE_PENALTY = 1.25f;
        
	public static final float SUPPLY_USE_MULT = 1.3f;
        
    @Override
    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

            stats.getEffectiveArmorBonus().modifyPercent(id, ARMOR_BONUS_BASE);
            if (hullSize == HullSize.FIGHTER) {
                stats.getEffectiveArmorBonus().modifyFlat(id, ARMOR_FIGHTER);
                stats.getEngineHealthBonus().modifyMult(id, ENGINE_HEALTH_FIGHTER);
                //stats.getEmpDamageTakenMult().modifyMult(id, EMP_RESIST_FIGHTER);
		stats.getCombatEngineRepairTimeMult().modifyMult(id, 1f - REPAIR_RATE_FIGHTER * 0.01f);
            } else if (hullSize == HullSize.FRIGATE) {
                stats.getEffectiveArmorBonus().modifyFlat(id, ARMOR_FRIGATE);
            } else if (hullSize == HullSize.DESTROYER) {
                stats.getEffectiveArmorBonus().modifyFlat(id, ARMOR_DESTROYER);
            } else if (hullSize == HullSize.CRUISER) {
                stats.getEffectiveArmorBonus().modifyFlat(id, ARMOR_CRUISER);
            } else if (hullSize == HullSize.CAPITAL_SHIP) {
                stats.getEffectiveArmorBonus().modifyFlat(id, ARMOR_CAPITAL);
            }
            stats.getKineticDamageTakenMult().modifyMult(id, (1 - KINETIC_RESIST));
//            stats.getFragmentationDamageTakenMult().modifyMult(id, (1 - FRAG_RESIST));
//            stats.getArmorBonus().modifyMult(id, (1 - ARMOR_COMPOSITE));
//            stats.getArmorBonus().modifyPercent(id, (100 / (1 - ARMOR_COMPOSITE)) - 100);
//            stats.getShieldTurnRateMult().modifyMult(id, (1 - SHIELD_MOVEMENT_PENALTY));
//            stats.getShieldUnfoldRateMult().modifyMult(id, (1 - SHIELD_MOVEMENT_PENALTY));
//            stats.getShieldArcBonus().modifyMult(id, (1 - SHIELD_PENALTY));
//            stats.getShieldArcBonus().modifyPercent(id, (100 / (1 - SHIELD_PENALTY)) - 100);
            stats.getWeaponTurnRateBonus().modifyMult(id, (1 - TURRET_PENALTY));
            stats.getHighExplosiveDamageTakenMult().modifyMult(id, (EXPLOSIVE_PENALTY));
            stats.getDynamic().getStat(Stats.EXPLOSION_DAMAGE_MULT).modifyMult(id, 1.5f);
            stats.getDynamic().getStat(Stats.EXPLOSION_RADIUS_MULT).modifyMult(id, 1.2f);
            
            stats.getSuppliesPerMonth().modifyMult(id, SUPPLY_USE_MULT);
    }

    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
		
	if(index == 0) return "" + (int) ARMOR_BONUS_BASE + "%";
	if(index == 1) return "" + (int) (ARMOR_FRIGATE) + "/" + (int) (ARMOR_DESTROYER) + "/" + (int) (ARMOR_CRUISER) + "/" + (int) (ARMOR_CAPITAL);
	if(index == 2) return "" + (int) (KINETIC_RESIST * 100) + "%";
	if(index == 3) return "" + (int) (EXPLOSIVE_PENALTY * 100 * 2) + "%";
	if(index == 4) return "" + (int) (TURRET_PENALTY * 100) + "%";
	if(index == 5) return "30%"; //"" + (int) (100 * (SUPPLY_USE_MULT - 1)) + "%";
//	if(index == 3) return "" + (int) (ARMOR_COMPOSITE * 100) + "%";
//	if(index == 6) return "" + (int) (SHIELD_MOVEMENT_PENALTY * 100) + "%";
//	if(index == 7) return "" + (int) (SHIELD_PENALTY * 100) + "%";
        else {
            return null;
        }
    }

    @Override
    public boolean isApplicableToShip(ShipAPI ship) {
        return ship != null && ship.getHullSpec().getHullId().startsWith("xlu_");
    }
}
