package data.hullmods;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class xlu_breezer_rounds extends BaseHullMod {

        public static final float DAMAGE_BONUS = 15f;
        public static final float BOOSTER_DAMAGE = 25f;
        public static final float FLUX_DAMAGE_BONUS = 10f;
        public static final float FLUX_PROJ_SPEED = 20f;
        
        public static final float FIRING_VALUE = 10f;
		public static final float MANEUVER_PENALTY = 15f;
        public static final float FLUX_FIRING_PENALTY = 20f;
	
        public static final float FRAG_BONUS = 1.5f;
        public static final float PD_FRAG_BONUS = 1.25f;
        
        public static final float LARGE_OP = 4f;
        public static final float MEDIUM_OP = 2f;
        public static final float SMALL_OP = 1f;
        
    @Override
    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
            //if (!stats.getVariant().getHullSpec().getBuiltInMods().contains("xlu_armorclad")) {
            //    stats.getDynamic().getMod(Stats.LARGE_BALLISTIC_MOD).modifyFlat(id, LARGE_OP);
            //    stats.getDynamic().getMod(Stats.MEDIUM_BALLISTIC_MOD).modifyFlat(id, MEDIUM_OP);
            //    stats.getDynamic().getMod(Stats.SMALL_BALLISTIC_MOD).modifyFlat(id, SMALL_OP);
            //}
        
            stats.getBallisticWeaponDamageMult().modifyPercent(id, DAMAGE_BONUS);
            stats.getHitStrengthBonus().modifyPercent(id, BOOSTER_DAMAGE);
            
            stats.getBallisticRoFMult().modifyMult(id, 1f - FIRING_VALUE * 0.01f);
            stats.getAcceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
            stats.getDeceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
            stats.getTurnAcceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
            stats.getMaxTurnRate().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
		
    }
    
        @Override
        public void advanceInCombat(ShipAPI ship, float amount) {
            if (!ship.isAlive()) return;
            float Flux = ship.getFluxTracker().getFluxLevel();
            float InFlux = 0;
            ShipAPI playerShip = Global.getCombatEngine().getPlayerShip();
            MutableShipStatsAPI stats = ship.getMutableStats();
            
            if (Flux > 0.2 && Flux < 0.7) { InFlux = Flux - 0.2f; }
            else if (Flux >= 0.7) { InFlux = 0.5f; }
            else InFlux = 0f; 
            
            stats.getBallisticWeaponDamageMult().modifyPercent("xlu_breezer_rounds", FLUX_DAMAGE_BONUS * InFlux * 2);
            stats.getProjectileSpeedMult().modifyPercent("xlu_breezer_rounds", FLUX_PROJ_SPEED * InFlux * 2);
            stats.getBallisticRoFMult().modifyMult("xlu_breezer_rounds", 1f - (FLUX_FIRING_PENALTY * 0.01f * InFlux * 2));
            
            float DamBonus = FLUX_DAMAGE_BONUS;
            if (ship == playerShip){
                if (Flux > 0.2) {
                    Global.getCombatEngine().maintainStatusForPlayerShip("xlu_brzr_rnd_1", "graphics/icons/hullsys/infernium_injector.png",
                    "Weapons Heat Charge: ","+" + Math.round(DamBonus * InFlux * 2f) + "% Damage",false);
                    Global.getCombatEngine().maintainStatusForPlayerShip("xlu_brzr_rnd_2", "graphics/icons/hullsys/infernium_injector.png",
                    "Weapons Overheating: ","" + Math.round((1f - (0.2f * InFlux * 2f)) * 100f) + "% Firing Speed",false); }
                else {}
            }
        }	
        

    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
		
	if(index == 0) return "" + (int) ((DAMAGE_BONUS)) + "%";
	if(index == 1) return "" + (int) FIRING_VALUE + "%";
	if(index == 2) return "" + (int) MANEUVER_PENALTY + "%";
	if(index == 3) return "20" + "%";
	if(index == 4) return "70" + "%";
	if(index == 5) return "" + (int) FLUX_DAMAGE_BONUS + "%";
	if(index == 6) return "" + (int) FLUX_PROJ_SPEED + "%";
	if(index == 7) return "" + (int) FLUX_FIRING_PENALTY + "%";
	//if(index == 6) return "" + (int) BOOSTER_DAMAGE + "%";
	//if(index == 2) return "" + (int) SMALL_OP + "/" + (int) MEDIUM_OP + "/" + (int) LARGE_OP;
	//if(index == 2) return "" + (int) ((FRAG_BONUS * 100) - 100) + "%";
	//if(index == 3) return "" + (int) ((PD_FRAG_BONUS * 100) - 100) + "%";
        else {
            return null;
        }
    }

        //@Override
        //public boolean isApplicableToShip(ShipAPI ship) {
        //    return false;
		//return ship.getVariant().hasHullMod(XLU_HullMods.XLU_ARMORCLAD) && super.isApplicableToShip(ship);
        //}
    

    //@Override
    //public String getUnapplicableReason(ShipAPI ship) {
        //if (ship == null || !ship.getVariant().getHullMods().contains("xlu_armorclad")) {
        //    return "XLU Armorclad Works hullmod Required";
        //}
        
    //    return null;
    //}
}

    //    @Override
    //    public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
    //        if (ship != null) {

    //            for (WeaponAPI weapon : ship.getAllWeapons()) {
    //                float frag;
    //                if (weapon.getSpec() == null) continue;

                    //WeaponAPI spec = weapon.getSpec();
    //                if (weapon.getType() != WeaponType.BALLISTIC) continue;

                    //Affects exclusively to Weapon Damage type.
     //               if (weapon.getDamageType() != DamageType.FRAGMENTATION) continue;

                    //The add damage to a specific weeapon if it has PD or not.
    //                if (!weapon.hasAIHint(WeaponAPI.AIHints.PD)) {
    //                    frag = (float) weapon.getDamage().getDamage();
    //                    weapon.getDamage().setDamage((float) frag * FRAG_BONUS);
    //                }
    //                if (weapon.hasAIHint(WeaponAPI.AIHints.PD)) {
    //                    frag = (float) weapon.getDamage().getDamage();
    //                    weapon.getDamage().setDamage((float) frag * PD_FRAG_BONUS);
    //                }
    //            }
    //        }
    //}

//        @Override
//        public void advanceInCombat(ShipAPI ship, float amount) {
//             List weapons = ship.getAllWeapons();
//            List weapons = ship.getWeaponGroupsCopy();
//            Iterator iter = weapons.iterator();
//            while (iter.hasNext()) {
//                WeaponAPI weapon = (WeaponAPI)iter.next();
//                float frag = weapon.getDamage().getDamage();
                
//                if ((weapon.getType() == WeaponType.BALLISTIC) && (weapon.getDamageType() == DamageType.FRAGMENTATION) && !(weapon.hasAIHint(WeaponAPI.AIHints.PD))) {
//                    weapon.getDamage().setDamage((float) frag * FRAG_BONUS);
//                }
//                else if ((weapon.getType() == WeaponType.BALLISTIC) && (weapon.getDamageType() == DamageType.FRAGMENTATION) && (weapon.hasAIHint(WeaponAPI.AIHints.PD))) {
//                    weapon.getDamage().setDamage((float) frag * PD_FRAG_BONUS);
                    //weapon.getDamage().setStats(ship.getMutableStats().getHitStrengthBonus().percentMod(weapon, id, frag_strength));
                    //weapon.getDamage().setStats(ship.getMutableStats().getHitStrengthBonus().percentMod(ship, weapon, frag_strength));
//                }
//        }
//    }
    
    //@Override
        //public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
        //    List weapons = ship.getAllWeapons();
        //    Iterator iter = weapons.iterator();
        //    while (iter.hasNext()) {
        //        WeaponAPI weapon = (WeaponAPI)iter.next();
        //        float frag = weapon.getDamage().getDamage();
                
        //        if ((weapon.getType() == WeaponType.BALLISTIC) && (weapon.getDamageType() == DamageType.FRAGMENTATION) && !(weapon.hasAIHint(WeaponAPI.AIHints.PD))) {
        //            weapon.getDamage().setDamage(frag * FRAG_BONUS);
        //        }
        //        else if ((weapon.getType() == WeaponType.BALLISTIC) && (weapon.getDamageType() == DamageType.FRAGMENTATION) && (weapon.hasAIHint(WeaponAPI.AIHints.PD))) {
        //            weapon.getDamage().setDamage(frag * PD_FRAG_BONUS);
                    //weapon.getDamage().setStats(ship.getMutableStats().getHitStrengthBonus().percentMod(weapon, id, frag_strength));
                    //weapon.getDamage().setStats(ship.getMutableStats().getHitStrengthBonus().percentMod(ship, weapon, frag_strength));
        //        }
        //}
    //}
	