package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class xlu_juggernaught_hullmod extends BaseHullMod {
	
	public static final float SENSOR_ADD = 60f;
	public static final float PROFILE_ADD = 60f;
	public static final float SIGHT_BONUS = 10f;
	public static final float RANGE_BONUS = 10f;
	public static final float RANGE_FRIGATE = 50f;
	public static final float RANGE_DESTROYER = 40f;
	public static final float RANGE_CRUISER = 20f;
	public static final float TURRET_BONUS = 50f;
	public static final float TURRET_PENALTY = -20f;
	public static final float RADIUS_MULT = 1.33f;
	public static final float DAMAGE_MULT = 1.75f;

	public static final float SUPPLY_USE_MULT = 1.2f;
        
        @Override
        public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
            stats.getSensorStrength().modifyFlat(id, SENSOR_ADD);
            stats.getSensorProfile().modifyFlat(id, PROFILE_ADD);
            stats.getSightRadiusMod().modifyMult(id, (1 + ((100 + SIGHT_BONUS) / 100)));
            stats.getEnergyWeaponRangeBonus().modifyPercent(id, RANGE_BONUS);
            if (hullSize == HullSize.FRIGATE) {
                stats.getEffectiveArmorBonus().modifyPercent(id, RANGE_FRIGATE);
            } else if (hullSize == HullSize.DESTROYER) {
                stats.getEffectiveArmorBonus().modifyPercent(id, RANGE_DESTROYER);
            } else if (hullSize == HullSize.CRUISER) {
                stats.getEffectiveArmorBonus().modifyPercent(id, RANGE_CRUISER);
            }
            stats.getBallisticWeaponRangeBonus().modifyMult(id, (1 + (RANGE_BONUS / 100)));
            stats.getMissileWeaponRangeBonus().modifyMult(id, (1 + ((RANGE_BONUS / 100) / 1.5f)));
            stats.getMissileMaxSpeedBonus().modifyMult(id, (1 + (RANGE_BONUS / 100)));
            stats.getWeaponHealthBonus().modifyMult(id, (1 + (TURRET_BONUS / 100)));
            stats.getWeaponTurnRateBonus().modifyMult(id, (1 + (TURRET_PENALTY / 100)));
            stats.getDynamic().getStat(Stats.EXPLOSION_DAMAGE_MULT).modifyMult(id, DAMAGE_MULT);
            stats.getDynamic().getStat(Stats.EXPLOSION_RADIUS_MULT).modifyMult(id, RADIUS_MULT);
            
            stats.getSuppliesPerMonth().modifyMult(id, SUPPLY_USE_MULT);
        }
	
        @Override
        public String getDescriptionParam(int index, HullSize hullSize) {
		if(index == 0) return "" + (int) SENSOR_ADD;
		if(index == 1) return "" + (int) SIGHT_BONUS + "%";
		if(index == 2) return "" + (int) RANGE_BONUS + "%";
		if(index == 3) return "" + (int) TURRET_BONUS + "%";
		if(index == 4) return "" + (int) TURRET_PENALTY + "%";
                if(index == 5) return "20" + "%";
                else {
                    return null;
                }
        }

        @Override
        public boolean isApplicableToShip(ShipAPI ship) {
            return ship != null && ship.getHullSpec().getHullId().startsWith("ob_");
        }
}
