package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import data.scripts.ids.XLU_HullMods;
import java.util.HashSet;
import java.util.Set;

public class xlu_weapons_overhaul extends BaseHullMod {

        public static final float BALLISTIC_BONUS = 25f;
        public static final float BALLISTIC_AMMO = 50f;
        public static final float BALLISTIC_FLUX = 25f;
        public static final float FLUX_PENALTY = 33f;
        public static final float BOOSTER_DAMAGE = 20f;
/*        
    private static final Set<String> REQUIRED_HULLMODS = new HashSet<>();
    static
    {
        // This hullmod will automatically be removed, if one of these is missing
        // This prevents an autofit exploit/bug
        REQUIRED_HULLMODS.add("xlu_armorclad");
    }
*/
    private String ERROR = "xlu_missing";
    private String MOD = "xlu_weapons_overhaul";

    @Override
    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

            stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_BONUS);
            stats.getBallisticWeaponFluxCostMod().modifyMult(id, (1 -(BALLISTIC_FLUX / 100)));
            stats.getFluxDissipation().modifyMult(id, (1 -(FLUX_PENALTY / 100)));
            stats.getHitStrengthBonus().modifyPercent(id, BOOSTER_DAMAGE);
            
            if (!stats.getVariant().getHullSpec().getBuiltInMods().contains("xlu_breezer_rounds")) {
                stats.getBallisticAmmoBonus().modifyPercent(id, BALLISTIC_AMMO);
            }
    }
/*
    @Override
    public void applyEffectsAfterShipCreation(ShipAPI ship, String id){
        
        for (String tmp : REQUIRED_HULLMODS) {
            if (!ship.getVariant().getHullMods().contains(tmp)) {                
                ship.getVariant().removeMod(MOD);      
                ship.getVariant().addMod(ERROR);
            }
        }
    }
*/	
    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
		
	if(index == 0) return "" + (int) BALLISTIC_BONUS + "%";
	if(index == 1) return "" + (int) BALLISTIC_AMMO + "%";
	if(index == 2) return "" + (int) BALLISTIC_FLUX + "%";
//	if(index == 3) return "" + (int) FLUX_PENALTY + "%";
	if(index == 3) return "" + (int) FLUX_PENALTY + "%";
	if(index == 4) return "" + (int) BOOSTER_DAMAGE + "%";
	if(index == 5) return "Ammo capacity bonus will not be applied";
        else {
            return null;
        }
    }

        @Override
        public boolean isApplicableToShip(ShipAPI ship) {
		return ship.getVariant().hasHullMod(XLU_HullMods.XLU_ARMORCLAD) && super.isApplicableToShip(ship);
        }
    

    @Override
    public String getUnapplicableReason(ShipAPI ship) {
        if (ship == null || !ship.getVariant().getHullMods().contains("xlu_armorclad")) {
            return "XLU Armorclad Works hullmod Required";
        }
        
        return null;
    }
}
